﻿using System;
using System.Drawing;
using ThinkGeo.MapSuite.Core;

namespace Post8419
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Map1.MapUnit = GeographyUnit.DecimalDegree;
                Map1.BackColor = Color.AliceBlue;
                Map1.MapTools.MouseCoordinate.Enabled = true;
                Map1.CurrentExtent = new RectangleShape(-119.19596, 34.26746, -119.13382, 34.21965);

                WorldMapKitLayer worldMapKitDesktopOverlay = new WorldMapKitLayer();
                Map1.StaticOverlay.Layers.Add("worldMapKitDesktopOverlay", worldMapKitDesktopOverlay);
            }
        }

        private void Convert()
        {
            string dir = Server.MapPath(@"~\App_Data") + @"\";
            string originalFile = dir + "Original.shp";
            string convertedFmeFile = dir + "FME_Converted.shp";
            string convertedThinkgeoFile = dir + "TG_Converted.shp";

            MyProjection myProjection = new MyProjection();
            ShapeFileFeatureLayer.SaveToProjection(originalFile, convertedThinkgeoFile, myProjection, OverwriteMode.Overwrite);
            ShapeFileFeatureLayer.BuildIndexFile(convertedThinkgeoFile, BuildIndexMode.DoNotRebuild);
        }

        protected void cbFME_CheckedChanged(object sender, EventArgs e)
        {
            if (cbFME.Checked)
            {
                ShapeFileFeatureLayer FMEconvertedShapeLayer = new ShapeFileFeatureLayer(Server.MapPath(@"~\App_Data\FME_Converted.shp"));
                FMEconvertedShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.FillSolidBrush.Color = GeoColor.FromArgb(100, GeoColor.SimpleColors.Green);
                FMEconvertedShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.OutlinePen.Color = GeoColor.SimpleColors.Green;
                FMEconvertedShapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                if (!Map1.StaticOverlay.Layers.Contains("FMEconvertedShapeLayer"))
                {
                    Map1.StaticOverlay.Layers.Add("FMEconvertedShapeLayer", FMEconvertedShapeLayer);
                }
            }
            else
            {
                if (Map1.StaticOverlay.Layers.Contains("FMEconvertedShapeLayer"))
                {
                    Map1.StaticOverlay.Layers.Remove("FMEconvertedShapeLayer");
                }
            }
            Map1.StaticOverlay.Redraw();

        }

        protected void cbTG_CheckedChanged(object sender, EventArgs e)
        {
            if (cbTG.Checked)
            {
                ShapeFileFeatureLayer TGconvertedShapeLayer = new ShapeFileFeatureLayer(Server.MapPath(@"~\App_Data\TG_Converted.shp"));
                TGconvertedShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.FillSolidBrush.Color = GeoColor.FromArgb(100, GeoColor.SimpleColors.Red);
                TGconvertedShapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.OutlinePen.Color = GeoColor.SimpleColors.Red;
                TGconvertedShapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                if (!Map1.StaticOverlay.Layers.Contains("TGconvertedShapeLayer"))
                {
                    Map1.StaticOverlay.Layers.Add("TGconvertedShapeLayer", TGconvertedShapeLayer);
                }
            }
            else
            {
                if (Map1.StaticOverlay.Layers.Contains("TGconvertedShapeLayer"))
                {
                    Map1.StaticOverlay.Layers.Remove("TGconvertedShapeLayer");
                }
            }
            Map1.StaticOverlay.Redraw();
        }
    }
}
