﻿using System.Collections.Generic;
using MapSuiteProjection;
using ThinkGeo.MapSuite.Core;

namespace Post8419
{
    /// <summary>
    /// Convert ESPG 4267 (NAD27) to ESPG 4269 (NAD83) specially
    /// </summary>
    public class MyProjection : Projection
    {
        Datum datum;
        public MyProjection()
        {
            datum = new Datum();
        }

        protected override Vertex[] ConvertToExternalProjectionCore(double[] x, double[] y)
        {
            List<Vertex> results = new List<Vertex>();
            for(int i=0;i<x.Length;i++)
            {
                Geodetic geodetic = new Geodetic(y[i], x[i]);
                Geodetic result = datum.Geodetic_Datum_Shift(geodetic, Datum_Index.NAS_C, Datum_Index.NAR_C);
                results.Add(new Vertex(result.Longitude, result.Latitude));
            }
            return results.ToArray();
        }

        protected override Vertex[] ConvertToInternalProjectionCore(double[] x, double[] y)
        {
            List<Vertex> results = new List<Vertex>();
            for (int i = 0; i < x.Length; i++)
            {
                Geodetic geodetic = new Geodetic(y[i], x[i]);
                Geodetic result = datum.Geodetic_Datum_Shift(geodetic, Datum_Index.NAR_C, Datum_Index.NAS_C);
                results.Add(new Vertex(result.Longitude, result.Latitude));
            }
            return results.ToArray();
        }
    }
}
